#ifndef GUARD_sparseData_h
#define GUARD_sparseData_h

#include <vector>
#include <algorithm>
#include <cassert>
#include <string>
#include <random>
#include <tuple>
#include <cmath>


// index value pair
using INDEX = std::size_t;
using VALUE = double;

// sparse vector entry
struct SE
{
    SE()
    { }

    SE(INDEX i, VALUE v)
    : index(i)
    , value(v)
    { }

    INDEX index;
    VALUE value;
}; 

// end-of-sparse-vector marker
inline constexpr std::size_t END()
{ return std::numeric_limits<std::size_t>::max(); }


struct sparseData {
	std::vector<std::vector<SE>> data;
	std::vector<char> labels;
};

void loaddata(std::string filename, sparseData& data);
std::vector<SE> scaleAddSparseVectors(std::vector<SE> const& first_operand, std::vector<SE> const& second_operand, double first_scale, double second_scale);


#endif
